<?php	if( ! defined( 'BILLING_MODULE' ) ) die( "Hacking attempt!" );
/*
=====================================================
 Billing
-----------------------------------------------------
 megakassa.ru
-----------------------------------------------------
 This code is copyrighted
=====================================================
*/

class Payment{

  var $doc = 'https://uspay.ru/doc/moduls';
  
  function Settings($config){

    $html = array();
    
    $html[] = array(
	  'ID Магазина:',
	  'Из настроек магазина в дичном кабинете uspay.ru',
	  '<input name="save_con[shop_id]" class="edit bk" type="text" value="' . $config['shop_id'] . '" style="width: 100%">'
    );
    
    $html[] = array(
      'Секретный ключ:',
      'Из настроек магазина в личном кабинете uspay.ru (небходимо использовать одинаковые секретный и публичный ключи)',
      '<input name="save_con[secret_key]" class="edit bk" type="password" value="' . $config['secret_key'] . '" style="width: 100%">'
    );
    
    $html[] = array(
      'Валюта оплаты:',
      'Используется на сайте uspay.ru',
      '<select name="save_con[server_currency]" class="uniform"><option value="RUB" ' . ($config['server_currency'] == 'RUB' ? 'selected' : '') . '>RUB</option></select>'
    );
    
    $html[] = array(
      'Режим работы:',
      'Выберите режим работы оплаты.',
      '<select name="save_con[server]" class="uniform">
				<option value="1" ' . ($config['server'] == 1 ? 'selected' : '') . '>Тестовый</option>
				<option value="" ' . (!$config['server'] ? 'selected' : '') . '>Рабочий</option>
			</select>'
    );
    
    $html[] = array(
      'Язык интерфейса:',
      'Выберите язык интерфейса оплаты.',
      '<select name="save_con[lang]" class="uniform">
				<option value="ru" ' . ($config['lang'] == 'ru' ? 'selected' : '') . '>Русский</option>
				<option value="en" ' . ($config['lang'] == 'en' ? 'selected' : '') . '>Английский</option>
			</select>'
    );
    
    return $html;

  }
  
  function Form($order_id, $config, $invoice, $currency, $description){

    $amount = number_format($invoice['invoice_pay'], 2, '.', '');
    $method_id = '';
    $client_email = '';
    $debug = $config['server'];
    $secret_key = $config['secret_key'];
	
	if(empty($description)){
	
      $description 	= 'Balance ' . $invoice['invoice_user_name'];
	
	}
	
  
    
    $hash = hash('sha256', $config['shop_id'].$amount.$config['secret_key'].$order_id);
    
  
			
		return '     <form method="POST" action="https://uspay.ru/merchant">
            <input type="hidden" name="amount" value="' . $amount . '">
            <input type="hidden" name="shop_id" value="' . $config['shop_id'] . '">
            <input type="hidden" name="label" value="' . $order_id . '">
            <input type="hidden" name="desc" value="' . base64_encode($description) . '">
            <input type="hidden" name="hash" value="'.$hash.'">
            <input type="submit" class="bs_button" value="Оплатить">
		
		
		
		
		
		            ';
    
  }
  
  function check_id($data) {
    return $data["order_id"];
  }
  
  function check_ok($data) {
    return 'ok';
  }
  
  function check_out($data, $config, $invoice) {
    global $_REQUEST;
    
    $ip_checked = false;
    
    foreach (array(
      'HTTP_X_CLUSTER_CLIENT_IP',
      'HTTP_X_FORWARDED_FOR',
      'HTTP_X_FORWARDED',
      'HTTP_FORWARDED_FOR',
      'HTTP_FORWARDED',
      'HTTP_CLIENT_IP',
      'REMOTE_ADDR'
    ) as $param) {
      if (!empty($_SERVER[$param]) && $_SERVER[$param] === '188.120.226.114'){
        $ip_checked = true;
        break;
      }
    }
    
  

    foreach (array(
      'label',
      'amount',
      'method',
      'shop_id',
      'test',
      'hash',
      'desc'
    ) as $field) {
      if (empty($_REQUEST[$field])) {
        return 'Error: have fields';
      }
    }

    $label = (int) $_REQUEST["label"];
    $pay = (int) $_REQUEST["pay"];
    $amount = (double) $_REQUEST["amount"];
    $method = $_REQUEST["method"];
    $shop_id = (int) $_REQUEST["shop_id"];
    $test = (int) $_REQUEST["test"];
    $hash = $_REQUEST["hash"];
    $desc = base64_decode($_REQUEST["method"]);
    
    $hashGen = hash('sha256',$shop_id.$amount.$config['secret_key'].$label.$pay);
    
    
    if ($hashGen !== $hash) {
      return 'Error: signature:: ' . $_REQUEST["hash"] . ' != ' . $hashGen;
    }
    
    if ($amount != number_format($invoice['invoice_pay'], 2, '.', '')) {
      return 'Error: amount';
    }
    
    if ($status == 'success') {
      return 200;
    }
    
    return "Error\n";

  }

}

$Paysys = new Payment;